<?
/*
###############################
#
# Administrative Messages Plugin script for CC
# verified with CC versions 1.9x
# http://www.jkirkpatrick.org/
#
###############################
#
# Date: Sept 14, 2004
# Web: http://www.jkirkpatrick.org/
# Mail: plugins@jkirkpatrick.org
#
###############################
#
#Copyright 2004 Jeremiah Kirkpatrick, All rights Reserved
#
###############################
06/02/05 - Brought up to speed with php5
06/06/05 - Added administrative personal messages
06/06/05 - Set to a GMT time standard instead of system time
06/06/05 - Reorganized Admin
06/06/05 - Added stripslashes to public views data, bug fix
07/24/05 - pages_url constant addition to messaging to handle non-standard CC Setups
10/07/05 - 95% user interface rewrite.
10/07/05 - Addition of a basic template system.
12/10/05 - Freeware Release - 1.10
*/
$plugins[]=array("name"=>"Administrative Messages", "classname"=>"admin_msgs");
class admin_msgs extends plugin_base
{
	var $class_name = "admin_msgs";
	var $path = 'adminmsg/';
	var $author = "Jeremiah K.";
	var $web = "http://www.jkirkpatrick.org/";
	var $name = "Administrative Messages (Freeware)";
	var $date = "12-08-05";
	var $table = "adminmsgs";
	var $version = '1.10';
	var $status;
	var $menu;
	var $file_name;
	var $ph;
	var $username;
	var $rep_max=100;
	var $time_gmt;
	var $time_local;
	function admin_msgs()
	{
		global $mysql_database, $HTTP_SESSION_VARS, $autousername;
		if($HTTP_SESSION_VARS['username'])
			$this->username=$HTTP_SESSION_VARS['username'];
		else if ($_SESSION['username'])
			$this->username=$_SESSION['username'];
		else if ($_COOKIE['autousername'])
			$this->username=$_COOKIE['autousername'];
		else
			$this->username=$autousername;
		$this->p_owner=system_value('tcp_owner');
		$this->path=dirname(__FILE__).'/';
		$this->time_local=mktime();
		$this->time_gmt=mktime(gmdate('H', $this->time_local), gmdate('i', $this->time_local), gmdate('s', $this->time_local), gmdate('m', $this->time_local), gmdate('j', $this->time_local), gmdate('Y', $this->time_local));
	}
	function load_page($page, $style=0)
	{
		switch(intval($style))
		{
			case '0':
			if(file_exists($page))
				include($page);
			else
				echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
			break;
			case '1':
			if(file_exists($page))
			{
				echo "<textarea cols=90 rows=40>\n";
				$fp=fopen($page, 'r');
				while(!feof($fp))
					echo fgets ($fp, 1024);
				fclose($fp);
				echo "</textarea>\n";
			}
			else
				echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
			break;
			default:
				echo "<font color=#FF0000>Load Page Error: Invalid load style... death...</font>\n";
				exit(1);
			break;
		}
	}
	function admin_page()
	{
		global $mysql_database, $HTTP_SESSION_VARS;
		$installed=$this->db_update();
		$table_list=@mysql_list_tables($mysql_database);
		$this->menu="<h1 align=center>$this->name</h1>
		<p align=center><a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name\">Main</a>&nbsp|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=manage_global\">Manage Global</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=manage_personal\">Manage Personal</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=about\">About</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=readme\">Read Me</a>&nbsp|&nbsp\n";
		if($installed || $_GET['page']=='install')
			$this->status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=uninstall\">Uninstall</a></p>";
		if(!$installed || $_GET['page']=='uninstall')
			$this->status="<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=install\"><font color=#FF0000>Install</font></a></p>";
		if($_GET['page']) $load=&$_GET['page'];
		if($_POST['page']) $load=&$_POST['page'];
		echo $this->menu.$this->status;
		if(method_exists($this, $load))
		{call_user_func(array($this, $load));$this->page_footer();return;}
		$page=$this->path.'main.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo "<font color=#FF0000>Missing or renamed required configuration file!($page)</font>\n";
		$this->page_footer();
	}
	function db_update()
	{
		global $mysql_database, $HTTP_SESSION_VARS;
		$table_list=@mysql_list_tables($mysql_database);
		for ($i = 0; $i < @mysql_num_rows($table_list); $i++)
		{
			$table=@mysql_tablename($table_list, $i);
			if($table == $this->table.'_main')
				$installed=TRUE;
		}
		$version=system_value($this->class_name.'_version');
		if($version!=$this->version && $installed)
		{
			$page=$this->path.'db_update.admin.php';
			if(file_exists($page))
			{
				include($page);
				return $installed;
			}else{
				$this->file_error($page);
				return $installed;
			}
		}
		return $installed;
	}
	function manage_global()
	{
		$page=$this->path.'global.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo $this->missing_file;
	}

	function manage_personal()
	{
		$page=$this->path.'personal.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo $this->missing_file;
	}
	function runner($force='')
	{
		global $HTTP_SESSION_VARS, $pages_url;
		if($_GET['EA'] || $_GET['PA'] || $_GET['AS'] || $force)
		{
			if($this->username)
			{
				$messages=@mysql_query("SELECT `num` FROM `".$this->table."_main` WHERE `expire` > '".$this->time_gmt."' ORDER BY `num` ASC");
				while($row=@mysql_fetch_array($messages, MYSQL_ASSOC))
				{
					if(!@mysql_num_rows(@mysql_query("SELECT `num` FROM `".$this->table."_result` WHERE `username`='$this->username' AND `num`='$row[num]'")))
					{
						header('Location: '.pages_url.'adminmsg.php?start='.$_GET['start'].'&view='.$row['num'].'&type=global&redirect='.rawurlencode($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']));
						exit();
					}
				}
				$messages=@mysql_query("SELECT `num` FROM `".$this->table."_personal` WHERE `username`='".$this->username."' AND `viewed`='0' ORDER BY `num` ASC LIMIT 1");
				if(!@mysql_num_rows($messages))
					return;
				$row=@mysql_fetch_array($messages, MYSQL_ASSOC);
				header('Location: '.pages_url.'adminmsg.php?start='.$_GET['start'].'&view='.$row['num'].'&type=personal&redirect='.rawurlencode($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']));
				exit();
			}
		}
	}
	function public_page()
	{
		if(!$this->db_update())
			return;
		$tpl=new CAdmsgUserForm($this->table, $this->username, $this->time_gmt);
		if(intval($_GET['view'])>0)
		{
			if($_GET['submit'])
			{
				$tpl->CreditView($_GET['view']);
				return;
			}
			switch($_GET['type'])
			{
				case 'personal':
					$tpl->ShowPersonal(1, intval($_GET['view']));
					break;
				default:
				case 'global':
					$tpl->ShowGlobal(1, intval($_GET['view']));
					break;
			}
			return;
		}
		$tpl->DisplayIndex();
	}
	function readme()
	{
		$this->load_page($this->path.'README', 1);
	}
	function about()
	{
		$this->load_page($this->path.'about.admin.php', 0);
	}
	function install()
	{
		$query = "CREATE TABLE `".$this->table."_main` (
 `num` INT( 11 ) NOT NULL AUTO_INCREMENT,
 `require_choice` CHAR (1) NOT NULL,
 `type` VARCHAR ( 10 ) NOT NULL,
 `title` VARCHAR ( 50 ) NOT NULL,
 `expire` BIGINT(20) NOT NULL,
 `date` BIGINT(20) NOT NULL,
 `message` BLOB NOT NULL,
 `options` BLOB NOT NULL,
 PRIMARY KEY ( `num` )
)";
		if(!@mysql_query($query))
			echo "<p align=center><font color=#FF0000>Failed to install database table `".$this->table."_main`.</font>(".mysql_error().")</p>\n";
		$query = "CREATE TABLE `".$this->table."_result` (
 `num` INT( 11 ) NOT NULL,
 `username` VARCHAR ( 16 ) NOT NULL,
 `selections` BLOB NOT NULL,
 `date` BIGINT (20) NOT NULL,
 KEY `num` ( `num` ),
 KEY `users` ( `username` )
)";
		if(!@mysql_query($query))
			echo "<p align=center><font color=#FF0000>Failed to install database table `".$this->table."_result`.</font>(".mysql_error().")</p>\n";
$query = "CREATE TABLE `".$this->table."_personal` (
 `num` INT( 11 ) NOT NULL AUTO_INCREMENT,
 `username` VARCHAR ( 16 ) NOT NULL,
 `title` VARCHAR ( 50 ) NOT NULL,
 `date` BIGINT(20) NOT NULL,
 `message` BLOB NOT NULL,
 `viewed` BIGINT(20) NOT NULL,
 PRIMARY KEY ( `num` ),
 KEY `username` ( `username` ),
 KEY `viewed` ( `viewed` )
)";
		if(!@mysql_query($query))
			echo "<p align=center><font color=#FF0000>Failed to install database table `".$this->table."_personal`.</font>(".mysql_error().")</p>\n";
	}
	function uninstall()
	{
		if(!@mysql_query("DROP TABLE `".$this->table."_main`"))
			echo "<p align=center><font color=#FF0000>Failed to remove database table `".$this->table."_main`.</font></p>\n";
		if(!@mysql_query("DROP TABLE `".$this->table."_result`"))
			echo "<p align=center><font color=#FF0000>Failed to remove database table `".$this->table."_result`.</font></p>\n";
		if(!@mysql_query("DROP TABLE `".$this->table."_personal`"))
			echo "<p align=center><font color=#FF0000>Failed to remove database table `".$this->table."_personal`.</font></p>\n";

	}
	function page_footer()
	{
		echo '<hr width=80%><table border="0" width="100%" align="center">
<tr bgcolor="#DDDDDD">
<td align="left" colspan="2"><p>These plugins are now offered as freeware to anybody who wishes to use them. </td></tr>';
	/*BEGIN COPYRIGHT NOTICE*/
	/*WARNING: TAMPERING WITH THIS SECTION OF CODE OR OTHERWISE CIRCUMVENTING IT'S EXECUTION BY BLOCKING OR REMOVING THE FUNCTION CALLS IS A VIOLATION IN THE FREEWARE LICENSE AGREEMENT WHICH GOVERNS YOUR USE OF THIS SCRIPT.*/
echo '<tr>
<td colspan="2" align="center">
'.$this->name.'<br>
&copy;2006 JKirkpatrick, All Rights Reserved<br>
</td>
</tr>';
	/*END COPYRIGHT NOTICE*/
echo '</table>';
	}
}
/*
	USER INPUT FORM CONTROL/DISPLAY CLASS
*/
class CAdmsgUserForm
{
	var $num;				//Message Number
	var $type;				//Message Type 0=global;1=personal
	var $username;			//Member's Name
	var $nixtime;			//Current Time
	var $message;			//Message Data
	var $table;				//MySQL Table Prefix
	var $global_tpl;		//Global Template File
	var $person_tpl;		//Personal Template File
	var $index_tpl;		//Index Template File
	var $script_file;		//Script File
	var $start;				//Starting Message Number (Navigation)
	var $amount;			//Index Amount
	var $time_local;		//Server Local Time
	var $time_gmt;			//GMT time
	function CAdmsgUserForm($table, $username, $time_gmt)
	{
		$this->table=$table;
		$this->num=intval($_GET['view']);
		$this->type=intval($_GET['type']);
		$this->script_file=$_SERVER['PHP_SELF'];
		$dirname=dirname(__FILE__);
		$this->global_tpl=$dirname.'/global.tpl';
		$this->person_tpl=$dirname.'/personal.tpl';
		$this->index_tpl=$dirname.'/main.tpl';
		if($_GET['start']) $this->start = intval($_GET['start']);else $this->start = 0;
		$this->amount = 20;
		$this->username=$username;
		$this->time_gmt=$time_gmt;
	}
	function CreditView()
	{
		if($this->username)
		{
			switch($_GET['type'])
			{
				case 'personal':
					$this->CreditPersonal($message);
					break;
				case 'global':
					if($this->CreditGlobal($message));
					break;
				default:
					break;
			}
		}
		$this->DisplayIndex();
	}
	function CreditPersonal($message)
	{
		$view=intval($_GET['view']);
		$fil_requested=rawurldecode($_GET['requested']);
		$cnt=@mysql_num_rows(@mysql_query("SELECT * FROM `".$this->table."_personal"."` WHERE `num`='$view' AND `username`='".$this->username."'"));
		if($cnt)
		{
			$result=@mysql_query("UPDATE `".$this->table."_personal` SET `viewed`='".$this->time_gmt."' WHERE `num`='$view' AND `username`='".$this->username."'");
			if(strpos($fil_requested, 'admin')===FALSE && $fil_requested)
				header('Location: '.$fil_requested);
			else
				header('Location: '.pages_url.'adminmsg.php?start='.$this->start);
			exit();
		}
	}
	function CreditGlobal($message)
	{
		$view=intval($_GET['view']);
		$fil_requested=rawurldecode($_GET['requested']);
		$fil_start=intval($_GET['start']);
		$table_row=@mysql_fetch_array(@mysql_query("SELECT * FROM `".$this->table."_main"."` WHERE `num`='$view'"));
		$selection='';
		$o_avail=explode("||", $table_row['options']);
		$i=0;
		foreach($o_avail as $value)
		{
			if($value)
				$op_avail[$i]=$value;
			$i++;
		}
		unset($o_avail);
		if(is_array($_GET['option']))
		{

			foreach($_GET['option'] as $value)
			{
				if($op_avail[$value])
					$selection.=addslashes($op_avail[$value])."||";
			}
		}else{
			if($_GET['option']!='')
				if($op_avail[$_GET['option']])
					$selection=$op_avail[$_GET['option']];
		}
		if($table_row['require_choice']==1 && $selection=='')
		{
			header('Location: '.pages_url.'adminmsg.php?start='.$this->start."&view=$view&redirect=$fil_requested");
			exit();
		}
		$cnt=@mysql_num_rows(@mysql_query("SELECT 'num' FROM `".$this->table."_result` WHERE `username`='$this->username' AND `num`='$view'"));
		if(!$cnt)
			@mysql_query("REPLACE INTO `".$this->table."_result` SET `num`='$view', `username`='$this->username', `selections`='$selection', `date`='".$this->time_gmt."'");
		else
			@mysql_query("UPDATE `".$this->table."_result` SET `selections`='$selection', `date`='".$this->time_gmt."' WHERE `username`='$this->username' AND  `num`='$view'");
		if(strpos($fil_requested, 'admin')===FALSE && $fil_requested)
			header('Location: '.$fil_requested);
		else
			header('Location: '.pages_url.'adminmsg.php?start='.$fil_start);
	}
	function ShowPersonal($makeform, $message=0)
	{
		$tpldata=$this->LoadTemplate($this->person_tpl);
		$tpldata=str_replace('[%script_file%]', $this->script_file, $tpldata);
		$tpldata=str_replace('[%start%]', $this->start, $tpldata);
		$tpldata=str_replace('[%view%]', $message, $tpldata);
		if($this->username)
			$tpldata=str_replace('[%redirect%]', $_GET['redirect'], $tpldata);
		else
			$tpldata=str_replace('[%redirect%]', '', $tpldata);
		$table_row=@mysql_fetch_array(@mysql_query("SELECT * FROM `".$this->table."_personal"."` WHERE `num`='$message' AND `username`='".$this->username."'"));
		$notfound=$this->FindString('error_not_found', $tpldata);
		if(!$table_row)
		{
			echo $notfound." $message, $this->username";
			return;
		}
		$tpldata=$this->InsertStringData('error_not_found', $tpldata, $notfound, '');
		$tpldata=str_replace('[%title%]', $table_row['title'], $tpldata);
		$tpldata=str_replace('[%message%]', $table_row['message'], $tpldata);
		echo $tpldata;
	}
	function ShowGlobal($makeform, $message=0)
	{
		$tpldata=$this->LoadTemplate($this->global_tpl);
		$tpldata=str_replace('[%script_file%]', $this->script_file, $tpldata);
		$tpldata=str_replace('[%start%]', $this->start, $tpldata);
		$tpldata=str_replace('[%view%]', $message, $tpldata);
		if($this->username)
			$tpldata=str_replace('[%redirect%]', $_GET['redirect'], $tpldata);
		else
			$tpldata=str_replace('[%redirect%]', '', $tpldata);
		$table_row=@mysql_fetch_array(@mysql_query("SELECT * FROM `".$this->table."_main"."` WHERE `num`='".$message."'"));
		$cur_sel=@mysql_fetch_array(@mysql_query("SELECT `selections` FROM `".$this->table."_result` WHERE `username`='$this->username' AND `num`='$message'"));
		$my_sel=explode("||", $cur_sel['selections']);
		unset($cur_sel);
		$notfound=$this->FindString('error_not_found', $tpldata);
		$choicerequired=$this->FindString('choice_required', $tpldata);
		$choiceradio=$this->FindString('choice_radio', $tpldata);
		$choicecheckbox=$this->FindString('choice_checkbox', $tpldata);
		$choicenooptions=$this->FindString('choice_no_options', $tpldata);
		if(!$table_row)
		{
			echo $notfound;
			return;
		}
		$tpldata=$this->InsertStringData('error_not_found', $tpldata, $notfound, '');
		$tpldata=str_replace('[%title%]', $table_row['title'], $tpldata);
		$tpldata=str_replace('[%message%]', $table_row['message'], $tpldata);
		if($table_row['require_choice'])
			$tpldata=$this->InsertStringData('choice_required', $tpldata, $choicerequired, $choicerequired);
		else
			$tpldata=$this->InsertStringData('choice_required', $tpldata, $choicerequired, '');
		$tpldata=$this->InsertStringData('choice_radio', $tpldata, $choiceradio, '');
		$tpldata=$this->InsertStringData('choice_checkbox', $tpldata, $choicecheckbox, '');
		$tpldata=$this->InsertStringData('choice_no_options', $tpldata, $choicenooptions, '');
		if($table_row['options']=='')
			$tpldata=str_replace('[%instructions%]',$choicenooptions, $tpldata);
		else if($table_row['type']=='radio')
			$tpldata=str_replace('[%instructions%]',$choiceradio, $tpldata);
		else if($table_row['type']=='checkbox')
			$tpldata=str_replace('[%instructions%]',$choicecheckbox, $tpldata);
		else
			$tpldata=str_replace('[%instructions%]','', $tpldata);
		$loop_code=$this->FindLoop('options', $tpldata);
		if($table_row['options']!='')
		{
			$options=explode("||", $table_row['options']);
			$i=0;
			foreach($options as $value)
			{
				if($value)
				{
					$tmp=$loop_code;
					$tmp=str_replace('[%opt_type%]', $table_row['type'], $tmp);
					if($table_row['type']=='radio')
						$tmp=str_replace('[%opt_name%]', 'option', $tmp);
					else
						$tmp=str_replace('[%opt_name%]', "option[$i]", $tmp);
					$tmp=str_replace('[%opt_value%]', $i, $tmp);
					$tmp=str_replace('[%opt_out%]', $value, $tmp);
					if(in_array($value, $my_sel))
						$tmp=str_replace('[%opt_sel%]', 'checked', $tmp);
					else
						$tmp=str_replace('[%opt_sel%]', '', $tmp);
					$i++;
					$loop_out.=$tmp;
				}
			}
		}
		echo $this->InsertLoopData('options', $tpldata, $loop_code, $loop_out);
	}
	function FindString($string, $tpldata)
	{
		$start_loc=strpos($tpldata, '[%startstring.'.$string.'%]')+strlen('[%startstring.'.$string.'%]');
		$end_loc=strpos($tpldata, '[%endstring.'.$string.'%]');
		$seg_length=$end_loc-$start_loc;
		if($seg_length<1)
			return FALSE;
		$retval=substr($tpldata, $start_loc, $seg_length);
		return $retval;
	}
	function CleanTemplate($tpldata)
	{
		$found=TRUE;
		while($found)
		{
			$eot=strlen($tpldata);
			$start_loc=strpos($tpldata, '/*');
			$end_loc=strpos($tpldata, '*/');
			if($end_loc!==FALSE)
				$end_loc=$end_loc+2;
			if($start_loc!==FALSE && $end_loc!==FALSE)
			{
				if($end_loc<$start_loc)
					return FALSE;
				$fb_len=$start_loc;
				$lb_len=$eot-$end_loc;
				$tpldata=substr($tpldata, 0, $start_loc).substr($tpldata, $end_loc, $lb_len);
			}
			else if($start_loc===FALSE && $end_loc===FALSE)
			{
				return $tpldata;
			}
			else if($start_loc!==FALSE && $end_loc===FALSE)
			{
				return FALSE;
			}
			else if($start_loc===FALSE && $end_loc!==FALSE)
			{
				return FALSE;
			}
		}
		return $tpldata;
	}
	function InsertStringData($string, $tpldata, $stringcode, $stringdata)
	{
		$repl_str='[%startstring.'.$string.'%]'.$stringcode.'[%endstring.'.$string.'%]';
		$tmp=str_replace($repl_str, '', $tpldata);
		$tmp=str_replace('[%dispstring.'.$string.'%]', $stringdata, $tmp);
		return $tmp; 
	}
	function FindLoop($loop, $tpldata)
	{
		$start_string='[%startloop.'.$loop.'%]';
		$end_string='[%endloop.'.$loop.'%]';
		$start_loop=strpos($tpldata, $start_string)+strlen($start_string);
		$end_loop=strpos($tpldata, $end_string);
		$seg_length=$end_loop-$start_loop;
		if($seg_length<1)
			return FALSE;
		$loop_code=substr($tpldata, $start_loop, $seg_length);
		return $loop_code;
	}
	function InsertLoopData($loop, $tpldata, $loopcode, $loopdata)
	{
		$start_string='[%startloop.'.$loop.'%]';
		$end_string='[%endloop.'.$loop.'%]';
		$tmp=str_replace($start_string, '', $tpldata);
		$tmp=str_replace($end_string, '', $tmp);
		$tmp=str_replace($loopcode, $loopdata, $tmp);
		return $tmp; 
	}
	function LoadTemplate($file)
	{
		if(!$fp=@fopen($file, 'r'))
		{
			echo "<p align=left><font color=#FF0000>Fatal Error: Template File ($file)<u>NOT</u> Found.</font></p>";
			return FALSE;
		}
		while(!feof($fp))
			$tpldata.=fread($fp, 1024);
		fclose($fp);
		$tpldata=$this->CleanTemplate($tpldata);
		if(!$tpldata)
		{
			echo "<p align=left><font color=#FF0000>Fatal Error: Problem with template file comment sections. Please verify comments have been setup correctly.</font></p>";
			return FALSE;
		}
		return $tpldata;
	}
	function DisplayIndex()
	{
		$tpldata=$this->LoadTemplate($this->index_tpl);
		$tpldata=str_replace('[%script_file%]', $this->script_file, $tpldata);
		$tpldata=str_replace('[%start%]', $this->start, $tpldata);
		$loop_code=$this->FindLoop('idx', $tpldata);
		if(!$loop_code)
		{
			echo "<p align=left><font color=#FF0000>Fatal Error: Failed to find &quot;idx&quot; loop in the file template, cannot display the index.</font></p>";
			return FALSE;
		}
		$count=@mysql_fetch_array(@mysql_query("SELECT count(*) AS `cnt` FROM `".$this->table."_main`;"));
		$result=@mysql_query("SELECT `num`, `title`, `date` FROM `".$this->table."_main` WHERE 1 ORDER BY `num` DESC LIMIT ".$this->start.", ".$this->amount.";");
		while($row=@mysql_fetch_array($result))
		{
			if($this->username)
				$table_row=@mysql_fetch_array(@mysql_query("SELECT `date` FROM `".$this->table."_result` WHERE `username`='".$this->username."' AND `num`='$row[num]'"));
			$created=date('M j, y g:i:s a', $row['date']).'&nbsp;GMT';
			if($table_row['date'])
				$viewed=date('M j, y g:i:s a', $table_row['date']).'&nbsp;GMT';
			else
				$viewed="Never";
			$tmp=str_replace('[%num%]', $row['num'], $loop_code);
			$tmp=str_replace('[%title%]', $row['title'], $tmp);
			$tmp=str_replace('[%created%]', $created, $tmp);
			$tmp=str_replace('[%viewed%]', $viewed, $tmp);
			$loop_out.=$tmp;
		}
		$prev=$this->FindString('prev', $tpldata);
		$next=$this->FindString('next', $tpldata);
		$next_num = $this->start+$this->amount;
		$prev_num = $this->start-$this->amount;
		if($next_num >= $count['cnt'])
			$next_num = -1;
		if($prev_num<0)
			$prev_num = -1;
		if($prev_num!=-1)
			$prev_out=str_replace('[%prev%]', $prev_num, $prev);
		else
			$prev_out='';
		if($next_num!=-1)
			$next_out=str_replace('[%next%]', $next_num, $next);
		else
			$next_out='';
		$tpldata=$this->InsertStringData('prev', $tpldata, $prev, $prev_out);
		$tpldata=$this->InsertStringData('next', $tpldata, $next, $next_out);
		echo $this->InsertLoopData('idx', $tpldata, $loop_code, $loop_out);
	}
}
